﻿// sensores.js

(function(ext) {
    var device = null;
    var _rxBuf = [];
    var switchStatus = {
		On:1,
		Off:0
	};
	var levels = {
		HIGH:1,
		LOW:0
	};
	var estados = {
		prender:1, apagar:0,
    "mostrar cursor":1, "ocultar cursor":2, "mostrar blink":3, "ocultar blink":4,
    "DHT11": 11, "DHT21": 21, "DHT22": 22, "AM2301": 21,
    "Temperatura [C]": 1, "Humedad [%]": 2, "Presión [hPa]": 2,
    "Altitud [m]": 3, "LPG [ppm]": 1, "CO [ppm]": 2, "Humo [ppm]": 3,
    "digital":0, "analógico":1,
    "cm":1, "inch":0,
    "GP2Y0A21YK":1,"GP2Y0A02YK0F":2,"GP2YA41SK0F":3,"GP2Y0A710K0F":4,
	};

	var values = {};
	var indexs = [];
	var startTimer = 0;
	var versionIndex = 0xFA;
	var responsePreprocessor = {};


	ext.resetAll = function(){
    	device.send([0xff, 0x55, 2, 0, 4]);
    	};

/***** DHT ****************************************************/
	ext.DHT_begin = function(modulo, pin){
    var deviceId = 110;
    runPackage(deviceId, pin, typeof modulo=="string"?estados[modulo]:new Number(modulo));
	};
  ext.DHT_get  = function(nextID,medir){
    var deviceId = 110;
    getPackage(nextID, deviceId, typeof medir=="string"?estados[medir]:new Number(medir));
	};
/***** UV ****************************************************/
ext.ML8511_begin  = function(pin){
  var deviceId = 120;
  runPackage(deviceId, pin);
 };
  ext.ML8511_get  = function(nextID){
    var deviceId = 120;
    getPackage(nextID, deviceId);       //  Intensidad UV [mW/cm2]
 };
/***** BH1750 *************************************************/
  ext.BH1750_get = function(nextID){
    var deviceId = 121;
    getPackage(nextID, deviceId);        // Intensidad Luz [lux]
	};
/***** LDR ***************************************************/
  ext.LDR_get = function(nextID, pin){
    var deviceId = 122;
    getPackage(nextID, deviceId, pin);        // Detector de luz LDR
	};
  /***** Flame *************************************************/
  ext.Flame_get  = function(nextID, pin, tipo){
    var deviceId = 123;
    getPackage(nextID, deviceId, pin, typeof tipo=="string"?estados[tipo]:new Number(tipo));
	};
  /***** Distanciometer ****************************************/
  ext.SharpIR_get  = function(nextID, pin, tipo){
    var deviceId = 124;
    getPackage(nextID, deviceId, pin, typeof tipo=="string"?estados[tipo]:new Number(tipo));
  };
/***** BMP180 *************************************************/
  ext.BMP180_get  = function(nextID, medir){
    var deviceId = 130;
    getPackage(nextID, deviceId, typeof medir=="string"?estados[medir]:new Number(medir));
	};
/***** BMP280 *************************************************/
  ext.BMP280_get  = function(nextID, medir){
    var deviceId = 131;
    getPackage(nextID, deviceId, typeof medir=="string"?estados[medir]:new Number(medir));
	};
/***** MQ2 ****************************************************/
 ext.MQ2_begin  = function(pin){
   var deviceId = 140;
   runPackage(deviceId, pin)
  };
  ext.MQ2_get  = function(nextID, medir){
    var deviceId = 140;
    getPackage(nextID, deviceId, typeof medir=="string"?estados[medir]:new Number(medir));
	};
/***** MQ7 ****************************************************/
 ext.MQ7_begin  = function(pin){
   var deviceId = 141;
   runPackage(deviceId, pin);
 };
  ext.MQ7_get  = function(nextID){
    var deviceId = 141;
    getPackage(nextID, deviceId);
	};
/***** MQ135 **************************************************/
 ext.MQ135_begin  = function(pin){
   var deviceId = 142;
   runPackage(deviceId, pin);
 };
  ext.MQ135_get  = function(nextID){
    var deviceId = 142;
    getPackage(nextID, deviceId);
	};
/***** Hygrometer *******************************************/
  ext.Hygrometer_get  = function(nextID, pin, tipo){
    var deviceId = 150;
    getPackage(nextID, deviceId, pin, typeof tipo=="string"?estados[tipo]:new Number(tipo));
	};
  /***** Water Level *****************************************/
    ext.WaterLevel_get  = function(nextID, pin, tipo){
      var deviceId = 151;
      getPackage(nextID, deviceId, pin, typeof tipo=="string"?estados[tipo]:new Number(tipo));
  	};
/***** Ultrasonic *********************************************/
 ext.Ultrasonic_begin  = function(trigger, echo){
   var deviceId = 160;
   runPackage(deviceId, trigger, echo);
 };
  ext.Ultrasonic_get  = function(nextID, unit, count){
    var deviceId = 160;
    getPackage(nextID, deviceId, count, typeof unit=="string"?estados[unit]:new Number(unit));
	};
/**************************************************************/




function sendPackage(argList, type){
  var bytes = [0xff, 0x55, 0, 0, type];
  for(var i=0;i<argList.length;++i){
    var val = argList[i];
    if(val.constructor == "[class Array]"){
      bytes = bytes.concat(val);
    }else{
      bytes.push(val);
    }
  }
  bytes[2] = bytes.length - 3;
  device.send(bytes);
}

function runPackage(){
  sendPackage(arguments, 2);
}
function getPackage(){
  var nextID = arguments[0];
  Array.prototype.shift.call(arguments);
  sendPackage(arguments, 1);
}

  var inputArray = [];
var _isParseStart = false;
var _isParseStartIndex = 0;
  function processData(bytes) {
  var len = bytes.length;
  if(_rxBuf.length>30){
    _rxBuf = [];
  }
  for(var index=0;index<bytes.length;index++){
    var c = bytes[index];
    _rxBuf.push(c);
    if(_rxBuf.length>=2){
      if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
        _isParseStart = true;
        _isParseStartIndex = _rxBuf.length-2;
      }
      if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd && _isParseStart){
        _isParseStart = false;

        var position = _isParseStartIndex+2;
        var extId = _rxBuf[position];
        position++;
        var type = _rxBuf[position];
        position++;
        //1 byte 2 float 3 short 4 len+string 5 double
        var value;
        switch(type){
          case 1:{
            value = _rxBuf[position];
            position++;
          }
            break;
          case 2:{
            value = readFloat(_rxBuf,position);
            position+=4;
          /*  if(value<-255||value>1023){
              value = 0;
            }*/
          }
            break;
          case 3:{
            value = readInt(_rxBuf,position,2);
            position+=2;
          }
            break;
          case 4:{
            var l = _rxBuf[position];
            position++;
            value = readString(_rxBuf,position,l);
          }
            break;
          case 5:{
            value = readDouble(_rxBuf,position);
            position+=4;
          }
            break;
          case 6:
            value = readInt(_rxBuf,position,4);
            position+=4;
            break;
        }
        if(type<=6){
          responseValue(extId,value);
        }else{
          responseValue();
        }
        _rxBuf = [];
      }
    }
  }
  }
function readFloat(arr,position){
  var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
  return (parseFloat(f)).toFixed(2);    // Ajuste a 2 decimales despues de la coma
}
function readInt(arr,position,count){
  var result = 0;
  for(var i=0; i<count; ++i){
    result |= arr[position+i] << (i << 3);
  }
  return result;
}
function readDouble(arr,position){
  return readFloat(arr,position);
}
function readString(arr,position,len){
  var value = "";
  for(var ii=0;ii<len;ii++){
    value += String.fromCharCode(_rxBuf[ii+position]);
  }
  return value;
}
  function appendBuffer( buffer1, buffer2 ) {
      return buffer1.concat( buffer2 );
  }

  // Extension API interactions
  var potentialDevices = [];
  ext._deviceConnected = function(dev) {
      potentialDevices.push(dev);

      if (!device) {
          tryNextDevice();
      }
  }

  function tryNextDevice() {
      // If potentialDevices is empty, device will be undefined.
      // That will get us back here next time a device is connected.
      device = potentialDevices.shift();
      if (device) {
          device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
      }
  }

  var watchdog = null;
  function deviceOpened(dev) {
      if (!dev) {
          // Opening the port failed.
          tryNextDevice();
          return;
      }
      device.set_receive_handler('arduino',processData);
  };

  ext._deviceRemoved = function(dev) {
      if(device != dev) return;
      device = null;
  };

  ext._shutdown = function() {
      if(device) device.close();
      device = null;
  };

  ext._getStatus = function() {
      if(!device) return {status: 1, msg: 'Board disconnected'};
      if(watchdog) return {status: 1, msg: 'Probing for Board'};
      return {status: 2, msg: 'Board connected'};
  }

  var descriptor = {};
ScratchExtensions.register('CSJB Sensores', descriptor, ext, {type: 'serial'});
})({});
