/*
	SharpIR
	Arduino library for retrieving distance (in cm) from the analog GP2Y0A21Y and GP2Y0A02YK
	From an original version of Dr. Marcal Casas-Cartagena (marcal.casas@gmail.com)

 Version : 1.0 : Guillaume Rico
https://github.com/guillaume-rico/SharpIR

*/

#ifndef _SharpIR_h
#define _SharpIR_h

#define NB_SAMPLE 10   // how many samples take the sensor

#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif

class SharpIR
{
  public:    SharpIR();
    				 int readDistance(float irPin, long sensorModel);

  private:   void sort(int a[], int size);
        		 int _irPin;
    		 		 long _model;
};

#endif  // end _SharpIR_h
