// Ultrasonic - Library for HR-SC04 Ultrasonic Module

#include "Ultrasonic.h"


#define   CM   1
#define   INC  0

// Constructor
Ultrasonic::Ultrasonic(){}

//APIs
void Ultrasonic::begin(int PT, int PE)
{
    _pinTrigger = PT;
    _pinEcho = PE;
    pinMode(_pinTrigger, OUTPUT);
    pinMode(_pinEcho, INPUT);
}


long Ultrasonic::distance(int n, bool unit)
{
  long prom=0;
  for (int i=1; i<=n; i++){
    prom+=timing();
  }
  duration = prom / n;

  if (unit){
    return  (duration / 29 / 2);
  }else{
    return (duration / 74 / 2);
  }
}


long Ultrasonic::timing()
{
  digitalWrite(_pinTrigger, LOW);
  delayMicroseconds(2);
  digitalWrite(_pinTrigger, HIGH);
  delayMicroseconds(10);
  digitalWrite(_pinTrigger, LOW);

  duration = pulseIn(_pinEcho,HIGH,Time_out);

  if ( duration == 0 ) {
  duration = Time_out;
  return duration;
  }

  return duration;
}
