// Ultrasonic - Library for HR-SC04 Ultrasonic Module

#ifndef _Ultrasonic_h
#define _Ultrasonic_h

#if ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif

class Ultrasonic
{
  public:    Ultrasonic();
             void begin(int PT, int PE);
             long distance(int n=1, bool unit=true);  // unit = 1  => cm , =0 => inch
             long timing(void);                       // n = es para promedio de mediciones

  private:
             long duration=0;
             long Time_out = 30000;    // 3000 µs = 50cm // 30000 µs = 5 m
             int _pinEcho;
             int _pinTrigger;
};

#endif // _Ultrasonic_h
